bool menu_visibility = false;
string ip = "127.0.0.1";
string port = "2350";

string errorTxt = "";

void RenderMenu()
{
	if(UI::MenuItem(Icons::Server + " Join Server by IP address", "", menu_visibility)) {
		menu_visibility = !menu_visibility;	
	}
    if(UI::MenuItem(Icons::Server + " Join localhost (port 2350)", "")) {
        auto appMP = cast<CGameManiaPlanet>(GetApp());
		CTrackMania@ app = cast<CTrackMania>(GetApp());
        if (appMP.LoadedManiaTitle == null){
            UI::ShowNotification("No titlepack loaded","Please enter a title pack before trying to connect to a server.", 5000);
        } else {
            string TitlePackId = appMP.LoadedManiaTitle.TitleId;
            app.ManiaPlanetScriptAPI.OpenLink("maniaplanet://#qjoin=127.0.0.1::2350@"+TitlePackId, CGameManiaPlanetScriptAPI::ELinkType::ManialinkBrowser);
        }
        
	}
}

void RenderInterface() {
	if (!menu_visibility) {
		return;
	}
	
    auto appMP = cast<CGameManiaPlanet>(GetApp());
    UI::SetNextWindowSize(440,240, UI::Cond::FirstUseEver);	
    CTrackMania@ app = cast<CTrackMania>(GetApp());

	if (UI::Begin("Join Server by IP address", menu_visibility)) {	
        if (appMP.LoadedManiaTitle == null){
            UI::Text("\\$f00"+Icons::Key+"\\$z Please enter a title pack before trying to connect to a server.");
        } else {
            string TitlePackId = appMP.LoadedManiaTitle.TitleId;
            UI::Text("\\$f00"+Icons::Info+"\\$z Only local (private) IP addresses are permitted, because of the game limitations.");
            ip = UI::InputText("IP address", ip, UI::InputTextFlags(UI::InputTextFlags::AutoSelectAll | UI::InputTextFlags::NoUndoRedo));
            port = UI::InputText("Port", port, UI::InputTextFlags(UI::InputTextFlags::AutoSelectAll | UI::InputTextFlags::NoUndoRedo));
            if (UI::Button("Join Now!")) {
                if(ip != "") {
                    if (Regex::IsMatch(ip, "^[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+$", Regex::Flags(Regex::Flags::CaseInsensitive | Regex::Flags::ECMAScript))){
                        if (
                            Regex::IsMatch(ip, "^10\\.[0-9]+\\.[0-9]+\\.[0-9]+$", Regex::Flags(Regex::Flags::CaseInsensitive | Regex::Flags::ECMAScript)) ||
                            Regex::IsMatch(ip, "^172\\.(1[6-9]|2[0-9]|3[0-1])\\.[0-9]+\\.[0-9]+$", Regex::Flags(Regex::Flags::CaseInsensitive | Regex::Flags::ECMAScript)) ||
                            Regex::IsMatch(ip, "^192\\.168\\.[0-9]+\\.[0-9]+$", Regex::Flags(Regex::Flags::CaseInsensitive | Regex::Flags::ECMAScript)) ||
                            Regex::IsMatch(ip, "^127\\.0\\.0\\.1$", Regex::Flags(Regex::Flags::CaseInsensitive | Regex::Flags::ECMAScript))
                        ){
                            if (port == "") port = "2350";
                            print("Joining " + ip + ":" + port);
                            string manialink = "maniaplanet://#qjoin="+ip+"::"+port+"@"+TitlePackId;
                            app.ManiaPlanetScriptAPI.OpenLink(manialink, CGameManiaPlanetScriptAPI::ELinkType::ManialinkBrowser);
                            errorTxt = "";
                        } else {
                            print("Not a private IP: "+ip);
                            errorTxt = "\\$f00This address is not a private address\\$z, please enter a private address such as 192.168.1.xx";
                        }
                    } else {
                        print("Unknown ip: "+ip);
                        errorTxt = "\\$f00Unknown IP\\$z, check your typings";
                    }
                } else {
                    print("Nothing is typed");
                    errorTxt = "\\$f00Nothing is typed\\$z";
                }
            }
            UI::Text(errorTxt);
        }
	}
	UI::End();
}